{% block title %}{% endblock %}
**此部分分值：**{{ prob.score }}分

## {{_("Description")}}

最终，菜菜自己也将虚拟机编写了出来。菜菜的虚拟机不仅实现了前文所述的所有要求，还增加了检查程序格式错误的功能。只有格式无误的程序才会被执行。出于测试的目的，菜菜希望你能用这套指令编写程序，在虚拟机上完成下述几个任务。每个任务的程序长度均不得多于 ${{ prob.args.code_limit }}$ 行。

## 样例任务

已知 $A$ 和 $B$，输出 $A$ 和 $B$ 中的较小值。

$A$ 和 $B$ 已经存放于内存当中，$A$ 存放在 $3000$ 处，$B$ 存放在 $3002$ 处。

### 任务解释

包括后面的任务，在没有特殊说明的情况下，所有的已知数据均默认为四位十六进制无符号整数。这里称“$A$ 存放在 $3000$ 处”，意味着 $3000$ 处存放着 $A$ 的低8位（二进制位），$3001$ 处存放着 $A$ 的高8位（二进制位）。**其余没有存放已知数据的内存和寄存器，均已被初始化为 $0$。**

在求得答案后，只需要使用 `ECHO` 指令将其输出即可。

如果提交的程序长度小于等于 ${{ prob.args.code_limit }}$ 行、没有格式错误、能通过 `STOP` 指令正常结束，并且输出了正确的答案，你将会得到该任务相应的分数。

内存情况示意图：

{{ render("table('table1')") }}

上图即为A等于43（十进制），B等于21（十进制）时内存的初始情况。

### 样例程序
```
RUN
MOV AX T3000
MOV BX T3002
CMP AX BX
JNL 0008
ECHO AX
JMP 0009
ECHO BX
STOP
```

## 任务1（10分）

已知 $N$（$N > 0$）个数 $A_1,A_2,\dots,A_N$，试输出它们的最大值。

$A_1,A_2,\dots,A_N$ 均已存放在内存的数据段中，依次位于 $3000,3002,3004,\dots$

寄存器 `AX` 存储了 $A_N$ 所在地址。

## 任务2（15分）

已知 $N$（$N > 0$）个数 $A_1,A_2,\dots,A_N$，试输出其中不同的值的个数。

$A_1,A_2,\dots,A_N$ 均已存放在内存的数据段中，依次位于 $3000,3002,3004,\dots$

寄存器 `AX` 存储了 $A_N$ 所在地址。

保证 $N$ 和 $A_1,A_2,\dots,A_N$ 均小于等于 $5 \times 10^3$。

## 任务3（20分）

已知 $N$（$N > 0$）和 $M$，试输出组合数 $C_N^M$ 对 $65536$ 取模的结果。

寄存器 `AX` 存储了 $N$ 的值，寄存器 `BX` 存储了 $M$ 的值。

$$
C_N^M = \frac{N!}{M!\left(N-M\right)!}
$$
这里 $N!$ 表示 $N$ 的阶乘，$0!=1$。

保证 $M \le N \le 2 \times 10^2$。